// FOOIMPL : Implementation of TFooImpl (CoClass: Foo, Interface: IFoo)

#include <vcl.h>
#pragma hdrstop

#include "FOOIMPL.H"

/////////////////////////////////////////////////////////////////////////////
// TFooImpl

STDMETHODIMP TFooImpl::get_MachineName(BSTR* Value)
{
  try
  {
    char Name[MAX_COMPUTERNAME_LENGTH + 1];
    unsigned long Len = sizeof(Name);
    Win32Check(GetComputerName(Name, &Len));
    WideString WName = Name;
    *Value = WName.Copy();
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IFoo);
  }
  return S_OK;
};


STDMETHODIMP TFooImpl::get_UserName(BSTR* Value)
{
  try
  {
    char Name[256];
    unsigned long Len = sizeof(Name);
    Win32Check(GetUserName(Name, &Len));
    WideString WName = Name;
    *Value = WName.Copy();
  }
  catch(Exception &e)
  {
    return Error(e.Message.c_str(), IID_IFoo);
  }
  return S_OK;
};


